pipeline {
    agent any
    tools {nodejs "node"}
    environment {
        CI = 'true' 
    }
  stages {
    stage('Installing Dependencies') {
      steps {
        sh 'export PATH=/usr/local/bin:$PATH'
        sh 'npm install -verbose'
      }
    }
    stage('Unit Tests (Karma)') {
      steps {
        sh 'node_modules/.bin/ng test'
      }
    }
    stage('Build') {
      steps {
        sh 'node_modules/.bin/ng build --prod'
      }
    }
    stage('Build Docker Image') {
      steps {
        sh 'docker build -t dineshjgd/angularjenkins:latest .'
      }
    }
    stage('Push Docker Image') {
      steps {
        echo 'Inside Push Docker Image'
        withCredentials([string(credentialsId: 'docker-pwd', variable: 'dockerHubPwd')]) {
           echo 'Inside Push Docker Image 2' 
           sh "docker login -u dineshjgd -p ${dockerHubPwd}"
        }
        sh 'docker push dineshjgd/angularjenkins:latest'
      }
    }
    stage('Deployment on remote server') {
      steps {
        script {
          def dockerRun = 'sudo docker run -d --name angularapp -p 3000:80 dineshjgd/angularjenkins:latest'
          def dockerStopDelete = 'sudo docker stop angularapp || true && sudo docker rm angularapp || true'
          def dockerContainerRemove = 'sudo docker rm -f angularapp'
          def dockerImageRemove = 'sudo docker rmi dineshjgd/angularjenkins:latest'
          sshagent(['AWSLogin']) {
            sh "ssh -o StrictHostKeyChecking=no ubuntu@13.233.166.139 ${dockerContainerRemove}"
            sh "ssh -o StrictHostKeyChecking=no ubuntu@13.233.166.139 ${dockerImageRemove}"
            withCredentials([string(credentialsId: 'docker-pwd', variable: 'dockerHubPwd')]) {
              echo 'Inside Deployment - Docker Login' 
              sh "docker login -u dineshjgd -p ${dockerHubPwd}"
            }
            sh "ssh -o StrictHostKeyChecking=no ubuntu@13.233.166.139 ${dockerRun}"
          }
        }
      }
      post { 
        failure {
          script {
            def dockerRun = 'sudo docker run -d --name angularapp -p 3000:80 dineshjgd/angularjenkins:latest'
            sshagent(['AWSLogin']) {
              withCredentials([string(credentialsId: 'docker-pwd', variable: 'dockerHubPwd')]) {
              echo 'Inside Failure - Deployment' 
              sh "docker login -u dineshjgd -p ${dockerHubPwd}"
            }
            sh "ssh -o StrictHostKeyChecking=no ubuntu@13.233.166.139 ${dockerRun}"
          }
         }
        }
      }
    }
    stage('E2E Testing (Protractor)') {
      steps {
        sh 'node_modules/.bin/ng e2e'
      }
    }
  }
}